Some cleanup
[backups/.git] / scripts / burn-imgs.sh
index a180c4d494cac54a3f4cc6243780baba172318d5..69d192fd4c3ba92eb3d5adbcf1cb3b66d456084b 100755 (executable)
 #!/bin/sh
 
-mailto=carl@ecbaldwin.net
-dev="/dev/hdc"
-sdev="ATA:1,0,0"
-imagedir="/backup/imgs"
-
-img=$(ls $imagedir | head -n 1)
-echo $img
-
-if [ -n "$img" ]; then
-  if cdrecord-wrapper.sh -dao speed=8 dev=$sdev $isoimage; then
-    md5sum=$(tempfile)
-    dd if=$dev bs=1M count=4440 | md5sum | awk '{print$1}' > $md5sum
-    if ! cmp $md5sum $isoimage.md5sum; then
-      echo "Failed" | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
+export PATH=$(dirname $0):/bin:/usr/bin:/sbin
+
+# source the default configuration
+. config.sh
+
+# source the system specific configuration
+[ -f /etc/lsbackups.conf ] && . /etc/lsbackups.conf
+
+# If the noburn file is there then don't burn.
+[ -f "$noburnfile" ] && exit 0
+
+# Discover disk images by looking for .iso.md5sum files in $imagedir
+imgmd5=$(ls $imagedir/*.iso.md5sum 2>/dev/null | head -n 1)
+
+# If we didn't find an non-empty file then exit gracefully
+[ -z "$imgmd5" ] && exit 0
+[ -s "$imgmd5" ] || exit 0
+
+logfile=$(tempfile)
+
+# Get the name of the disk image by stripping off the tailing '.md5sum'
+img=${imgmd5%.md5sum}
+
+touch $noburnfile
+
+# Now check to see if we need to cache the image to a local drive before burning the image
+if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+  rsync -av --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+  if [ $? != 0 ]; then
+    sleep 60
+    rsync -aIv --exclude '*.mnt' $img* $cacheburnimgdir >> $logfile 2>&1
+    if [ $? != 0 ]; then
+      cat $logfile | mailx -s "backups: failed to cache $img to local dir $cacheburnimgdir !!!" $mailto
       exit 1
-    else
-      echo $md5sum >> $img.stat
     fi
-  else
-    echo "Failed" | mailx -s "DVD burning failed!!!" $mailto
-    exit 1
   fi
+  img=$cacheburnimgdir/$(basename "$img")
+fi
+
+# A little paranoia.  Make sure the disk image file is there.
+[ -z "$img" ] && exit 1
+[ -s "$img" ] || exit 1
+
+# To avoid buffer underruns I'm going to stop cron and renice myself
+$cronstopstart stop
+renice -10 $$
 
-  {
-    echo "Image md5sum:"
-    cat $img.md5sum
-    echo
-    echo "md5sum of burned disks:"
-    cat $img.stat
-  } | mailx -s "DVD burned.  File it as ${img%.*}" $mailto
+# Burn the image to a disk.
+cdrecord-wrapper.sh $cdrecordopts dev=$sdev $img >> $logfile 2>&1
 
-  if [ "$(wc -l $img.stat 2>/dev/null)" == "2" ]; then
-    echo "Burned the image twice.  Removing it!"
+if [ "0" != "$?" ]; then
+  echo >&2 "cdrecord failed!"
+  $cronstopstart start
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "backups: failed to burn $img!!!" $mailto
+  exit 1
+fi
+
+# We don't need to be high-priority anymore.
+renice 0 $$
+$cronstopstart start
+
+# I don't know if this *really* helps but give cdrecord a chance to clean up.
+sleep 60
+
+# Now verify the disk by running md5sum on the entire contents of the disk
+md5sum=$(tempfile)
+dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print$1}' > $md5sum
+
+# Check that the md5sums match
+if ! cmp $md5sum $img.md5sum; then
+  echo "md5sum check FAILED" >> $logfile
+  echo "dd if=$dev bs=1M count=$imagesizemb 2>>$logfile | md5sum | awk '{print\$1}' > $md5sum" >> $logfile
+  e2label $dev >> $logfile 2>&1
+  cat $logfile | grep -v -e '[\b\r]' | mailx -s "DVD md5sum doesn't match image file!!!" $mailto
+  exit 1
+fi
+
+# Record the date in the stat file to indicate that this burn was a success
+date >> $img.stat
+
+# Update the source file stat file if we burned a cached copy of the image
+[[ $cacheburnimg == 1 && -d $cacheburnimgdir ]] && date >> ${imgmd5%.md5sum}.stat
+
+{ # Send e-mail
+  echo "Image md5sum:"
+  cat $img.md5sum
+  echo
+  echo "md5sum of burned disks:"
+  cat $md5sum
+  echo
+  cat $img.stat
+  echo
+  cat $logfile
+} | grep -v -e '[\b\r]' | mailx -s "DVD burned.  File as $(basename ${img%.*})" $mailto >> $logfile 2>&1
+
+# Two lines in the stat file indicate two successful burns.  Clean-up the image.
+if [ "$(wc -l $img.stat 2>/dev/null | awk '{print$1}')" == "$makeXcopies" ]; then
+  # Burned the image $makeXcopies number of times.  Removing it and associated files! 
+  if [[ $cacheburnimg == 1 && -d $cacheburnimgdir ]]; then
+    # Remove our cached copy of the image, its md5sum, and stat file
     rm -f $img{,.md5sum,.stat}
-    rmdir $img.mnt
+    # Now restore our $img variable to point back to the original source file
+    img=${imgmd5%.md5sum}
   fi
+  rm -f $img{,.md5sum,.stat}
+  [ -d $img.mnt ] && rmdir $img.mnt
 fi
+